#pragma once

#include <iosfwd>
#include <vector>

/* A Stack is just a vector of MemoryCells. While you can technically do things
   like inserting into the middle or removing from the beginning, I recommend
   you treat this like an actual stack, i.e. only access elements with
   back() and pop_back(), and insert elements with push_back(). */
namespace gc {

class MemoryCell;
using Stack = std::vector<MemoryCell *>;

std::ostream &operator<<(std::ostream &, const Stack &);
std::ostream &printGrading(std::ostream &, const Stack &);
} // namespace gc
