#include "VirtualMachine.h"

#include <iostream>
#include <iterator>
#include <ostream>

using namespace gc;


/* Remember: passing these test cases *will not* ensure that your program gets
full points. This is especially true for this lab, where segfaults hide in weird
corners. Write your own tests!! */

int main() {
// Test Case 0: Simple stack manipulation functions, with no heap exhaustion
//  (so GC should never trigger)

/*
  VirtualMachine vm0(20);

  vm0.pushInt(1);
  vm0.pushInt(2);
  vm0.pushPair();
  vm0.dup();
  vm0.storeFirst();
  vm0.loadSecond();
  vm0.pushInt(3);
  vm0.add();

  std::cout << vm0 << '\n' << std::endl;
*/

// Test Case 1: Test manual GC forcing: stack should have one integer object
// after GC has run.

/*
  VirtualMachine vm1(20);

  vm1.pushInt(2);
  vm1.pushInt(3);
  vm1.add();
  vm1.gc();
  
  std::cout << vm1 << '\n' << std::endl;

// Test Case 2: Automatic GC. The following example should not run out of
// memory, although it will have to GC at least once on its own.

/*
  VirtualMachine vm2(7);
  vm2.pushInt(1);
  vm2.pushInt(2);
  vm2.pushPair();
  vm2.dup();
  vm2.storeFirst();
  vm2.loadFirst();
  vm2.pushInt(3);

  std::cout << vm2 << '\n' << std::endl;
*/

// Test Case 3: You had better make sure this one works, because it's going to
// be one of the examples you're graded on!  This should **not** OOM.

/*
  VirtualMachine vm3(4);
  vm3.pushInt(61);
  vm3.pushInt(62);
  vm3.add();
  vm3.pushInt(63);


  std::cout << vm3 << '\n' << std::endl;
*/

// Test Case 4: Are you leaking memory?

/*
  VirtualMachine vm4(10);
  for(int i = 0; i < 1000; i++){
    for(int j = 0; j < 5; j++){
      vm4.pushInt(i);
    }
    for(int j = 0; j < 5; j++){
      vm4.pop();
    }
  }
*/

}
